Ubuntu 14.04에 Unicorn 및 Nginx가 포함된 Rails 어플리케이션을 배포하는 방법

Ubuntu 14.04에 Unicorn 및 Nginx가 포함된 Rails 어플리케이션을 배포하는 방법

2022-06-01 last update

15 minutes reading Ubuntu Ruby on Rails Deployment Nginx PostgreSQL

소개


Ruby on Rails 응용 프로그램을 배포하려면 많은 유효한 설정을 고려해야 합니다.이 강좌는 Ubuntu 14.04에서 Unicorn과 Nginx를 사용하여 PostgreSQL을 데이터베이스로 하여 Ruby on Rails 응용 프로그램의 생산 환경을 배치하는 데 도움을 줄 것입니다.
유니콘은 Passenger 또는 Puma과 같은 응용 서버로 Rails 응용 프로그램이 동시에 요청을 처리할 수 있도록 한다.Unicorn은 사용자가 직접 액세스할 수 있도록 설계된 것이 아니므로 Nginx를 리버스 에이전트로 사용하여 사용자와 Rails 응용 프로그램 간의 요청과 응답을 버퍼링합니다.

선결 조건


이 강좌는 응용 프로그램을 배포하는 사용자에게 Ubuntu 14.04 서버를 설치하고 다음 소프트웨어를 설치했다고 가정합니다.
  • Ruby on Rails, using rbenv
  • PostgreSQL with Rails
  • 만약 설정하지 않았다면, 위 링크의 강좌에 따라 조작하십시오.사용자 이름이 deploy라고 가정합니다.
    이 강좌는 개발 또는 테스트 환경을 설정하는 방법을 소개하지 않습니다.이 방면의 도움이 필요하다면 PostgreSQL with Rails 강좌의 예시를 따르십시오.

    Rails 응용 프로그램 만들기


    이상적인 경우 배포할 Rails 애플리케이션이 이미 있습니다.이 경우 이 부분을 건너뛰고 다음 작업에서 적절한 교체를 할 수 있습니다.없으면 첫 번째 단계는 데이터베이스로 PostgreSQL을 사용하는 새로운 Rails 응용 프로그램을 만드는 것입니다.
    이 명령은 "appname"이라는 새 Rails 프로그램을 만듭니다. 이 프로그램은 PostgreSQL을 데이터베이스로 사용합니다.강조 표시된 "appname"을 다른 내용으로 대체할 수 있습니다.
    1. rails new appname -d postgresql
    그런 다음 응용 프로그램 디렉토리로 전환합니다.
    1. cd appname
    Rails 응용 프로그램의 운영 환경에서 사용할 PostgreSQL 사용자를 만드는 데 시간이 좀 걸립니다.

    운영 데이터베이스 사용자 만들기


    간단하게 말하자면, 우리는 생산 데이터베이스 사용자를 응용 프로그램 이름과 같은 이름으로 명명할 것이다.예를 들어, 응용 프로그램 이름이 "appname"이면 다음과 같은 PostgreSQL 사용자를 만들어야 합니다.
    1. sudo -u postgres createuser -s appname
    데이터베이스 사용자의 암호를 설정하려면 다음과 같이 PostgreSQL 콘솔에 들어가십시오.
    1. sudo -u postgres psql
    그리고 예시의 데이터베이스 사용자'appname'에 대한 비밀번호를 설정합니다. 아래와 같습니다.
    1. \password appname
    필요한 암호를 입력하고 확인합니다.
    다음 명령을 사용하여 PostgreSQL 콘솔을 종료합니다.
    1. \q
    현재, 우리는 정확한 데이터베이스 연결 정보를 사용하여 응용 프로그램을 설정할 준비가 되어 있습니다.

    데이터베이스 연결 구성


    응용 프로그램의 루트 디렉터리(cd ~/appname)에 있는지 확인하십시오.
    원하는 텍스트 편집기에서 응용 프로그램의 데이터베이스 프로필을 엽니다.vi:
    1. vi config/database.yml
    default 섹션에서 "pool:5"가 표시된 줄을 찾아 다음 줄을 추가합니다(해당 줄이 존재하지 않는 경우).
      host: localhost
    
    파일 아래쪽으로 스크롤하면 production 섹션이 다음과 같이 설정됩니다.
      username: appname
      password: <%= ENV['APPNAME_DATABASE_PASSWORD'] %>
    
    운영 사용자 이름이 이전에 만든 데이터베이스 사용자와 일치하지 않으면 지금 설정하십시오.
    데이터베이스 암호는 환경 변수 APPNAME_DATABASE_PASSWORD에서 읽도록 설정되어 있습니다.생산 비밀번호와 기밀을 응용 프로그램 코드 라이브러리에 보관하는 것은 최선의 방법으로 여겨진다. Git와 같은 분포식 버전 제어 시스템을 사용하면 쉽게 노출되기 때문이다.다음은 환경 변수를 사용하여 데이터베이스 인증을 설정하는 방법을 토론할 것이다.

    rbenv vars 플러그인 설치


    운영 Rails 애플리케이션을 배포하기 전에 환경 변수를 사용하여 운영 키 및 데이터베이스 암호를 설정해야 합니다.환경 변수를 관리하는 간단한 방법은 rbenvvars 플러그인을 사용하는 것입니다. 우리는 실행할 때 비밀번호와 기밀을 프로그램에 불러올 수 있습니다.
    rbenv vars 플러그인을 설치하려면 .rbenv/plugins 디렉터리로 변경하고 GitHub에서 복제하면 됩니다.예를 들어, 홈 디렉토리에 rbenv가 설치되어 있으면 다음 명령을 실행합니다.
    1. cd ~/.rbenv/plugins
    2. git clone https://github.com/sstephenson/rbenv-vars.git

    환경 변수 설정


    현재 rbenvvars 플러그인이 설치되어 있습니다. 필요한 환경 변수를 설정합니다.
    우선, 키를 생성합니다. 이 키는 서명 쿠키의 완전성을 검증하는 데 사용됩니다.
    1. cd ~/appname
    2. rake secret
    생성된 키를 복사한 다음 원하는 편집기로 .rbenv-vars 파일을 엽니다.vi:
    1. vi .rbenv-vars
    Rails 응용 프로그램은 이 설정의 모든 환경 변수를 읽을 수 있습니다.
    먼저 다음과 같은 SECRET_KEY_BASE 변수를 설정합니다(강조 표시된 텍스트를 방금 생성되고 복사된 기밀로 바꿉니다).
    SECRET_KEY_BASE=your_generated_secret
    
    다음에 APPNAME_DATABASE_PASSWORD 변수를 설정합니다(강조 표시된 "APPNAME"를 응용 프로그램 이름으로 바꾸고, "prod\udb\upass"를 생산 데이터베이스 사용자 암호로 바꾸십시오).
    APPNAME_DATABASE_PASSWORD=prod_db_pass
    
    저장하고 종료합니다.
    다음 명령을 실행하면 rbenv vars 플러그인을 사용하여 응용 프로그램에 설정된 환경 변수를 볼 수 있습니다.
    1. rbenv vars
    암호 또는 데이터베이스 암호를 변경하면 .rbenv-vars 파일을 업데이트합니다.이 파일은 공공 코드 저장소에 포함되지 않도록 주의하십시오.

    운영 데이터베이스 생성


    이제 응용 프로그램이 PostgreSQL 데이터베이스와 통신하도록 구성되었으며 다음 운영 데이터베이스를 만듭니다.
    1. RAILS_ENV=production rake db:create

    생성 컨트롤러


    다음 예제에 따라 작업을 진행하면 응용 프로그램이 볼 수 있도록 scaffold 컨트롤러를 생성합니다.
    1. rails generate scaffold Task title:string note:text
    운영 데이터베이스를 업데이트하려면 이 명령을 실행합니다.
    1. RAILS_ENV=production rake db:migrate

    프리컴파일 자산


    이 때, 응용 프로그램은 작동할 수 있지만, 이미지, CSS, 스크립트를 불러올 수 있도록 자산을 미리 컴파일해야 합니다.이렇게 하려면 다음 명령을 실행하십시오.
    1. RAILS_ENV=production rake assets:precompile

    테스트 응용 프로그램


    어플리케이션이 작동하는지 테스트하려면 운영 환경을 실행하고 서버의 공용 IP 주소(서버의 공용 IP 주소 교체)에 바인딩할 수 있습니다.
    1. RAILS_ENV=production rails server --binding=server_public_IP
    웹 브라우저에서 이 URL에 액세스하려면 다음과 같이 하십시오.
    http://server_public_IP:3000/tasks
    
    정상적으로 작동하는 경우 다음 페이지가 표시됩니다.
    Tasks controller
    Rails 서버로 돌아가서 Ctrl-c을 눌러 애플리케이션을 중지합니다.

    Unicorn 설치


    이제 유니콘을 설치하려고 합니다.
    간단한 방법은 응용 프로그램의 Gemfile에 추가하는 것이다.원하는 편집기에서 Gemfile 열기 (응용 프로그램의 루트에 있는지 확인):
    1. vi Gemfile
    파일 끝에 다음 행을 사용하여 기린 보석을 추가합니다.
    gem 'unicorn'
    
    저장하고 종료합니다.
    Unicorn 및 해결되지 않은 종속성을 설치하려면 Bundler를 실행하십시오.
    1. bundle
    Unicorn이 설치되었으나 구성이 필요합니다.

    Unicorn 구성


    Unicorn 구성을 config/unicorn.rb에 추가합니다.텍스트 편집기에서 파일을 열려면 다음과 같이 하십시오.
    1. vi config/unicorn.rb
    이 구성을 복사하여 파일에 붙여넣습니다.
    # set path to application
    app_dir = File.expand_path("../..", __FILE__)
    shared_dir = "#{app_dir}/shared"
    working_directory app_dir
    
    
    # Set unicorn options
    worker_processes 2
    preload_app true
    timeout 30
    
    # Set up socket location
    listen "#{shared_dir}/sockets/unicorn.sock", :backlog => 64
    
    # Logging
    stderr_path "#{shared_dir}/log/unicorn.stderr.log"
    stdout_path "#{shared_dir}/log/unicorn.stdout.log"
    
    # Set master PID location
    pid "#{shared_dir}/pids/unicorn.pid"
    
    저장하고 종료합니다.이것은 응용 프로그램의 위치와 플러그인, 로그, PID 위치를 사용하여 Unicorn을 구성합니다.파일을 임의로 수정하거나 필요한 다른 옵션을 추가할 수 있습니다.
    이제 구성 파일에서 참조하는 디렉토리를 만듭니다.
    1. mkdir -p shared/pids shared/sockets shared/log

    Unicorn 초기화 스크립트 만들기


    유니콘을 쉽게 시작하고 정지할 수 있도록 init 스크립트를 만들고 안내할 때 시작할 수 있도록 합니다.
    스크립트를 만들고 편집하기 위해 이 명령을 사용합니다. (원한다면 강조 표시된 부분을 응용 프로그램 이름으로 바꾸십시오.)
    1. sudo vi /etc/init.d/unicorn_appname
    다음 코드 블록을 복사하여 붙여넣고, USERAPP_NAME(강조 표시)을 적절한 값으로 교체해야 합니다.
    #!/bin/sh
    
    ### BEGIN INIT INFO
    # Provides:          unicorn
    # Required-Start:    $all
    # Required-Stop:     $all
    # Default-Start:     2 3 4 5
    # Default-Stop:      0 1 6
    # Short-Description: starts the unicorn app server
    # Description:       starts unicorn using start-stop-daemon
    ### END INIT INFO
    
    set -e
    
    USAGE="Usage: $0 <start|stop|restart|upgrade|rotate|force-stop>"
    
    # app settings
    USER="deploy"
    APP_NAME="appname"
    APP_ROOT="/home/$USER/$APP_NAME"
    ENV="production"
    
    # environment settings
    PATH="/home/$USER/.rbenv/shims:/home/$USER/.rbenv/bin:$PATH"
    CMD="cd $APP_ROOT && bundle exec unicorn -c config/unicorn.rb -E $ENV -D"
    PID="$APP_ROOT/shared/pids/unicorn.pid"
    OLD_PID="$PID.oldbin"
    
    # make sure the app exists
    cd $APP_ROOT || exit 1
    
    sig () {
      test -s "$PID" && kill -$1 `cat $PID`
    }
    
    oldsig () {
      test -s $OLD_PID && kill -$1 `cat $OLD_PID`
    }
    
    case $1 in
      start)
        sig 0 && echo >&2 "Already running" && exit 0
        echo "Starting $APP_NAME"
        su - $USER -c "$CMD"
        ;;
      stop)
        echo "Stopping $APP_NAME"
        sig QUIT && exit 0
        echo >&2 "Not running"
        ;;
      force-stop)
        echo "Force stopping $APP_NAME"
        sig TERM && exit 0
        echo >&2 "Not running"
        ;;
      restart|reload|upgrade)
        sig USR2 && echo "reloaded $APP_NAME" && exit 0
        echo >&2 "Couldn't reload, starting '$CMD' instead"
        $CMD
        ;;
      rotate)
        sig USR1 && echo rotated logs OK && exit 0
        echo >&2 "Couldn't rotate logs" && exit 1
        ;;
      *)
        echo >&2 $USAGE
        exit 1
        ;;
    esac
    
    저장하고 종료합니다.그러면 service unicorn_appname을 사용하여 Unicorn 및 Rails 애플리케이션을 시작 및 중지할 수 있습니다.
    스크립트의 권한을 업데이트하고 부트할 때 Unicorn을 활성화합니다.
    1. sudo chmod 755 /etc/init.d/unicorn_appname
    2. sudo update-rc.d unicorn_appname defaults
    지금부터 시작합시다.
    1. sudo service unicorn_appname start
    현재 Rails 응용 프로그램의 생산 환경이 Unicorn에서 실행되고 있으며, shared/sockets/unicorn.sock 소켓을 탐지하고 있습니다.외부 사용자가 응용 프로그램에 액세스하기 전에 Nginx 리버스 에이전트를 설정해야 합니다.

    Nginx 설치 및 구성


    apt get을 사용하여 Nginx 설치:
    1. sudo apt-get install nginx
    이제 텍스트 편집기를 사용하여 기본 서버 블록을 엽니다.
    1. sudo vi /etc/nginx/sites-available/default
    파일의 내용을 다음 코드 블록으로 대체합니다.강조 표시된 부분을 적절한 사용자 이름과 응용 프로그램 이름으로 교체해야 합니다.
    upstream app {
        # Path to Unicorn SOCK file, as defined previously
        server unix:/home/deploy/appname/shared/sockets/unicorn.sock fail_timeout=0;
    }
    
    server {
        listen 80;
        server_name localhost;
    
        root /home/deploy/appname/public;
    
        try_files $uri/index.html $uri @app;
    
        location @app {
            proxy_pass http://app;
            proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
            proxy_set_header Host $http_host;
            proxy_redirect off;
        }
    
        error_page 500 502 503 504 /500.html;
        client_max_body_size 4G;
        keepalive_timeout 10;
    }
    
    저장하고 종료합니다.이것은 Nginx를 역방향 프록시로 설정하기 때문에 HTTP는 유닉스 플러그인을 통해 유닉스 응용 서버로 전송할 것을 요청합니다.만약 당신이 적합하다고 생각한다면 임의로 변경할 수 있습니다.
    변경 사항을 적용하려면 Nginx를 다시 시작합니다.
    1. sudo service nginx restart
    이제 서버의 공용 IP 주소 또는 FQDN을 통해 Rails 애플리케이션의 운영 환경에 액세스할 수 있습니다.이전에 만든 작업 컨트롤러에 액세스하려면 웹 브라우저에서 응용 프로그램 서버에 액세스하십시오.
    http://server_public_IP/tasks
    
    응용 프로그램을 처음 테스트할 때와 같은 페이지를 보셔야 하지만, 지금은 Nginx와 Unicorn을 통해 서비스를 제공합니다.

    결론


    축하Nginx와 Unicorn을 사용하여 Ruby-on-Rails 응용 프로그램의 운영 환경을 구축했습니다.
    운영 Rails 어플리케이션 배포를 개선하려면 How To Use Capistrano to Automate Deployments에서 튜토리얼 시리즈를 확인해야 합니다.이 제품군은 CentOS를 기반으로 하지만 자동화된 배포에 도움이 됩니다.